<template>
  <SinglePane capt="Роли пользователей">
    <ObTable
      :items="roles"
      :columns="columns"
      :functional-panel="true"
      :is-functional-sort="false"
      :is-functional-group="false"
      :show-add-button="true"
      class="roles-table"
      @select="onSelectRole"
      @add="onAddRole"
    >
      <div
        slot="roleCount"
        slot-scope="{ data }"
        class="role-number"
      >
        {{ data.item.worker_roles_to_keycloak_roles_count }}

        <span class="-gray-slate">/ {{ keycloakRolesCount }}</span>
      </div>

      <div
        slot="roleTitle"
        slot-scope="{ data }"
        class="role-badge"
      >
        <i :class="[ 'icon role-badge__icon', iconByRoleV3(data.item.contractor_role_code) ]" />

        {{ data.item.contractor_role_title || '—' }}
      </div>
    </ObTable>

    <RoleModal
      ref="roleModal"
      :data-source="selectedRole"
      :contractor-roles="contractorRoles"
      @reload-table="getUserRoles"
    />
  </SinglePane>
</template>

<script>
  import SinglePane from 'common-components/src/obComponents/obSinglePanels'
  import ObTable from 'common-components/src/obComponents/obTable'
  import RoleModal from './modal/role'
  import { iconByRoleV3 } from '@/helpers/user'
  import moment from 'moment'
  import api from '@/api'

  export default {
    name: 'user-roles-new',
    components: {
      SinglePane,
      ObTable,
      RoleModal
    },
    computed: {
      columns () {
        return [
          {
            title: 'Роль пользователя',
            key: 'title',
          },
          {
            title: 'Кол-во элементарных ролей',
            key: 'functions_count',
            slotName: 'roleCount',
            exactWidth: '116px'
          },
          {
            title: 'Роль участника',
            key: 'contractor_role_title',
            slotName: 'roleTitle'
          },
          {
            title: 'Дата изменения',
            key: 'created_at',
            html: ({ updated_at }) => updated_at ? moment(updated_at).format('DD.MM.YY') : ''
          },
          {
            title: 'Статус',
            key: 'is_active',
            html: ({ is_active }) => is_active ? 'Активна' : 'Неактивна'
          }
        ]
      }
    },
    data () {
      return {
        roles: [],
        contractorRoles: [],
        keycloakRolesCount: 0,
        selectedRole: {}
      }
    },
    async mounted () {
      this.getUserRoles()

      this.contractorRoles = await api.user_roles.getContractorRoles()
      this.contractorRoles = this.contractorRoles.map((role) => {
        return {
          ...role,
          icon: iconByRoleV3(role.code)
        }
      })
    },
    methods: {
      iconByRoleV3,
      async onSelectRole (selectedRole) {
        try {
          const contractor_role_uuid = this.contractorRoles.find(role => selectedRole.contractor_role_title === role.title).uuid

          const { keycloak_roles } = await api.user_roles.getWorkerRoleKeycloakRoles(selectedRole.uuid)

          this.selectedRole = {
            ...selectedRole,
            contractor_role_uuid,
            keycloak_roles: keycloak_roles.sort((a, b) => a.localeCompare(b))
          }

          this.$refs.roleModal.open()
        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        }
      },
      onAddRole () {
        this.selectedRole = {}

        this.$refs.roleModal.open()
      },
      async getUserRoles () {
        try {
          const { worker_roles, keycloak_roles_count } = await api.user_roles.getUserRolesNew()

          this.roles = worker_roles
          this.keycloakRolesCount = keycloak_roles_count
        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        }
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .role-badge {
    @include font-mixin(14px, 18px, 400, $color-text-base);

    display: flex;
    align-items: center;

    &__icon {
      color: $blue-700;
      font-size: 16px;
      margin-right: 10px;
      position: relative;
      top: -1px; // To visually centering icon
    }
  }

  ::v-deep .roles-table {
    td,
    th {
      &:nth-child(2) .td-container {
        justify-content: center;
        text-align: center;
      }
    }
  }
</style>
